## START: Set by rpmautospec
## (rpmautospec version 0.6.0)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global version 0.14.0
%global reponame WasmEdge
%global capi_soname 0
%global capi_version 0.1.0

Name:    wasmedge
Version: %{version}
Release: %autorelease
Summary: High performance WebAssembly Virtual Machine
# The entire source code is ASL 2.0 except LICENSE.spdx which is CC0
License: ASL 2.0 and CC0
URL:     https://github.com/%{reponame}/%{reponame}
Source0: %{url}/releases/download/%{version}/%{reponame}-%{version}-src.tar.gz
Patch0:  0001-Common-include-spdlog-fmt-ranges.h-for-fmt-join.patch
BuildRequires: cmake
BuildRequires: gcc-c++
BuildRequires: git
BuildRequires: lld-devel
BuildRequires: llvm-devel
BuildRequires: ninja-build
BuildRequires: spdlog-devel
Requires:      lld
Requires:      llvm
Requires:      spdlog
# Currently wasmedge could only be built on specific arches
ExclusiveArch: x86_64 aarch64
Provides: %{reponame} = %{version}-%{release}
Provides: bundled(blake3) = 1.2.0
Provides: bundled(wasi-cpp-header) = 0.0.1
Provides: wasm-library
Conflicts: %{name}-rt

%description
High performance WebAssembly Virtual Machine

%package rt
Summary: %{reponame} Runtime
Requires: spdlog
Provides: %{reponame}-rt = %{version}-%{release}
Provides: bundled(blake3) = 1.3.3
Provides: bundled(wasi-cpp-header) = 0.0.1
Provides: wasm-library
Conflicts: %{name}
RemovePathPostfixes: .rt

%description rt
This package contains only %{reponame} runtime without LLVM dependency.

%package devel
Summary: %{reponame} development files
Requires: %{name}%{?_isa} = %{version}-%{release}
Provides: %{reponame}-devel = %{version}-%{release}

%description devel
This package contains necessary header files for %{reponame} development.

%prep
%autosetup -p1 -n %{name}
[ -f VERSION ] || echo -n %{version} > VERSION

%build
%cmake -GNinja -DCMAKE_BUILD_TYPE=RelWithDebInfo -DBUILD_SHARED_LIBS=OFF -DWASMEDGE_BUILD_TESTS=OFF
%cmake_build
mkdir rt
cd rt
%cmake -S .. -GNinja -DCMAKE_BUILD_TYPE=RelWithDebInfo -DBUILD_SHARED_LIBS=OFF -DWASMEDGE_BUILD_TESTS=OFF -DWASMEDGE_BUILD_AOT_RUNTIME=OFF
%cmake_build

%install
cd rt
%cmake_install
mv %{buildroot}%{_bindir}/wasmedge{,.rt}
mv %{buildroot}%{_libdir}/lib%{name}.so.%{capi_version}{,.rt}
mv %{buildroot}%{_libdir}/lib%{name}.so.%{capi_soname}{,.rt}
mv %{buildroot}%{_libdir}/lib%{name}.so{,.rt}
rm -rf %{buildroot}%{_includedir}
cd ..
%cmake_install

%files
%license LICENSE LICENSE.spdx
%doc Changelog.md README.md SECURITY.md
%{_bindir}/wasmedge
%{_bindir}/wasmedgec
%{_libdir}/lib%{name}.so.%{capi_version}
%{_libdir}/lib%{name}.so.%{capi_soname}

%files rt
%license LICENSE LICENSE.spdx
%doc Changelog.md README.md SECURITY.md
%{_bindir}/wasmedge.rt
%{_libdir}/lib%{name}.so.%{capi_version}.rt
%{_libdir}/lib%{name}.so.%{capi_soname}.rt
%{_libdir}/lib%{name}.so.rt

%files devel
%dir %{_includedir}/%{name}
%{_includedir}/%{name}/enum.inc
%{_includedir}/%{name}/enum_configure.h
%{_includedir}/%{name}/enum_errcode.h
%{_includedir}/%{name}/enum_types.h
%{_includedir}/%{name}/int128.h
%{_includedir}/%{name}/version.h
%{_includedir}/%{name}/wasmedge.h
%{_libdir}/lib%{name}.so

%changelog
## START: Generated by rpmautospec
* Mon Jul 15 2024 Kefu Chai <tchaikov@gmail.com> - 0.14.0-2
- Rebuilt for fmt 11

* Thu May 30 2024 dm4 <dm4@secondstate.io> - 0.14.0-1
- Release 0.14.0

* Tue May 21 2024 František Zatloukal <fzatlouk@redhat.com> - 0.13.5-3
- Rebuilt for spdlog 1.14.1

* Sat Jan 27 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.13.5-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_40_Mass_Rebuild

* Mon Nov 13 2023 dm4 <dm4@secondstate.io> - 0.13.5-1
- Release 0.13.5

* Thu Sep 14 2023 hydai <hydai@hyd.ai> - 0.13.4-1
- Release 0.13.4

* Thu Jul 27 2023 dm4 <dm4@secondstate.io> - 0.13.3-1
- Release 0.13.3

* Fri Jul 21 2023 dm4 <dm4@secondstate.io> - 0.13.2-1
- Release 0.13.2

* Sat Jul 08 2023 Vitaly Zaitsev <vitaly@easycoding.org> - 0.13.1-2
- Rebuilt due to spdlog 1.12 update.

* Fri Jul 07 2023 dm4 <dm4@secondstate.io> - 0.13.1-1
- Release 0.13.1

* Tue Jul 04 2023 dm4 <dm4@secondstate.io> - 0.12.1-3
- Apply the patch for fmt 10 update

* Wed Jun 28 2023 Vitaly Zaitsev <vitaly@easycoding.org> - 0.12.1-2
- Rebuilt due to fmt 10 update.

* Fri May 12 2023 dm4 <dm4@secondstate.io> - 0.12.1-1
- Release 0.12.1

* Thu Apr 27 2023 dm4 <dm4@secondstate.io> - 0.12.0-1
- Release 0.12.0

* Thu Mar 02 2023 dm4 <dm4@secondstate.io> - 0.11.2-2
- Add wasmedge-rt package

* Fri Nov 04 2022 dm4 <dm4@secondstate.io> - 0.11.2-1
- Release 0.11.2

* Thu Nov 03 2022 Lokesh Mandvekar <lsm5@fedoraproject.org> - 0.11.1-2
- Provides: wasm-library

* Fri Oct 21 2022 dm4 <dm4@secondstate.io> - 0.11.1-1
- Release 0.11.1

* Wed Aug 31 2022 dm4 <dm4@secondstate.io> - 0.11.0-1
- Release 0.11.0

* Mon Aug 01 2022 dm4 <dm4@secondstate.io> - 0.10.1-1
- Initial import (fedora#2035222).
## END: Generated by rpmautospec
